$regfile = "2313def.dat"
$crystal = 8000000

Config Pind.0 = Output                                      'Anoda 1
Config Pind.1 = Output                                      'Anoda 2
Config Pind.3 = Output                                      'Grzaka
Config Pind.5 = Input                                       'Tryb pracy
Config Pinb.0 = Output                                      'A
Config Pinb.1 = Output                                      'F
Config Pinb.2 = Output                                      'B
Config Pinb.3 = Output                                      'E
Config Pinb.4 = Output                                      'G
Config Pinb.5 = Output                                      'C
Config Pinb.6 = Output                                      'D
Config Pinb.7 = Output                                      'Gotowo
Config Pind.2 = Output                                      'Nieuywany
Config Pind.4 = Output                                      'Nieuywany

Config 1wire = Pind.6

Config Watchdog = 512

Config Timer0 = Timer , Prescale = 64
On Timer0 Czas
Timer0 = 6
Enable Interrupts

Dim Lsb As Byte
Dim Msb As Byte
Dim Pm As Integer
Dim Pm1 As Integer
Dim Temp As Byte
Dim Nr As Bit
Dim Al As Bit
Dim Tryb As Bit
Dim A As Byte
Dim B As Byte
Dim Port As Byte

Start Watchdog
Reset Watchdog

Set Portd.5
Set Portd.2
Set Portd.4
Set Portd.1
Set Portd.0

Triak Alias Portd.3
Led Alias Portb.7

Reset Portb.0
Reset Portb.1
Reset Portb.2
Reset Portb.3
Reset Portb.4
Reset Portb.5
Reset Portb.6

A = 10
B = 10
Temp = 0
1wreset
1wwrite &HCC
1wwrite &H44

Enable Timer0

Do
Tryb = Pind.5
Loop
End

Czas:
Timer0 = 6
Reset Watchdog
Incr Pm
If Pm = 400 Then
   Disable Timer0
   'Odczytaj now temperatur
   1wreset
   1wwrite &HCC
   1wwrite &HBE
   Lsb = 1wread():
   Msb = 1wread():
   1wreset
   'Zmierz od nowa
   1wreset
   1wwrite &HCC
   1wwrite &H44
   'Obrbka wartoci temperatury
   Pm = Msb * 256
   Pm = Pm + Lsb
   Pm = Pm / 16
   Temp = Abs(pm)
   If Temp > 84 Or Temp = 0 Then
      A = 10
      B = 10
      Temp = 99
      Reset Triak
      Reset Led
   Else
      A = Makebcd(temp)
      B = A And &B00001111
      Shift A , Right , 4
   End If
   Pm = 0
   'Sprawdzanie temperatury i sterowanie grzak
   If Tryb = 0 Then
      If Temp > 40 Then
         Reset Portd.3
      Else
         Set Portd.3
      End If
      'Diody gotowoci
      If Temp > 37 And Temp < 43 Then
         Set Led
      Else
         Reset Led
      End If
   Else
      If Temp > 50 Then
         Reset Portd.3
      Else
         Set Portd.3
      End If
      'Diody gotowoci
      If Temp > 47 And Temp < 53 Then
         Set Led
      Else
         Reset Led
      end if
   End If
   Enable Timer0
End If

'Wywietlanie biecej temperatury
Set Portd.0
Set Portd.1
Toggle Nr
If Nr = 1 Then
   Reset Portd.1
   Port = Lookup(a , Kody)
Else
   Reset Portd.0
   Port = Lookup(b , Kody)
End If
'Katody
Portb.0 = Port.0
Portb.1 = Port.1
Portb.2 = Port.2
Portb.3 = Port.3
Portb.4 = Port.4
Portb.5 = Port.5
Portb.6 = Port.6
Return

Kody:
Data &B00010000 , &B01011011 , &B00100010 , &B00001010 , &B01001001,       '0 - 4
Data &B00001100 , &B00000100 , &B01011010 , &B00000000 , &B00001000,       '5 - 9
Data &B01101111 ,                                           ' -